(a) The easiest strategy is to find the time spent aloft,
and then find the range. The vertical motion and the
horizontal motion are independent. The vertical motion has
acceleration $-g$, and the cannonball spends enough time in
the air to reverse its vertical velocity component
completely, so we have
\begin{align*}
        \Delta v_y     &=  v_{yf}-v_{yo}  \\
             &=  -2v \sin  \theta    \qquad   .
\end{align*}
The time spent aloft is therefore
\begin{align*}
        \Delta t     &=  \Delta v_y/ a_y  \\
             &=  2v \sin  \theta  / g   \qquad   .
\end{align*}
During this time, the horizontal distance traveled is
\begin{align*}
        R     &=  v_x\Delta t  \\
             &=  2 v ^2 \sin  \theta \cos  \theta  / g   \qquad   .
\end{align*}
(b) The range becomes zero at both $\theta=0$ and at
$\theta=90\degunit$. The $\theta=0$ case gives zero range
because the ball hits the ground as soon as it leaves the
mouth of the cannon. A 90-degree angle gives zero range
because the cannonball has no horizontal motion.
